/*
 * BookListItem.h
 *
 *  Created on: 20/ott/2010
 *      Author: Luca Gambetta <l.gambetta@bluenine.it>
 */

#ifndef BOOKLISTITEM_H_
#define BOOKLISTITEM_H_

#include <QString>
#include <QStringList>
#include <QDateTime>
#include <QList>
#include <QListIterator>
#include <QMutableListIterator>
#include <QMetaType>

typedef struct BookListItem {
	explicit BookListItem(const QString &asin_ = QString(),
					   const QString &title_ = QString(),
					   const QString &author_ = QString(),
					   const QDateTime &date_ = QDateTime(),
					   const QString &country_ = QString(),
						const QString &username_ = QString(),
						const QString &isbn_ = QString(),
					   const QStringList genres_ = QStringList(), bool is_new_ = false ) :
	ASIN(asin_),
	title(title_),
	author(author_),
	date(date_),
	country(country_),
	username(username_),
	ISBN(isbn_),
	genres(genres_),
	is_new(is_new_)  {}

	bool operator< ( const QDateTime & other ) const { return date < other; }
	bool operator< (const QString &other) const { return title < other; }

	bool operator< (const BookListItem &other) const { return date < other.date; }

	bool operator==(const BookListItem &other) const { return ASIN == other.ASIN; }

	// ID univoco del libro
	QString ASIN;
	QString title;
	QString author;
	QDateTime date;
	QString country;
	QString username;
	QString ISBN;
	QStringList genres;
	bool is_new;
} BookListItem;

typedef QList<BookListItem> BookList;
typedef QListIterator<BookListItem> BookListIterator;
typedef QMutableListIterator<BookListItem> BookListMutableIterator;

Q_DECLARE_METATYPE(BookListItem)
Q_DECLARE_METATYPE(BookList)


#endif /* BOOKLISTITEM_H_ */
