/*
 * BookListProxyModel.cpp
 *
 *  Created on: 12/ott/2010
 *      Author: Luca Gambetta <l.gambetta@bluenine.it>
 */

#include "BookListProxyModel.h"
#include "BookListItem.h"

BookListProxyModel::BookListProxyModel(QObject *parent) : QSortFilterProxyModel(parent) {}

bool BookListProxyModel::filterAcceptsRow(int sourceRow, const QModelIndex &sourceParent) const {
	QModelIndex index = sourceModel()->index(sourceRow, 0, sourceParent);

	if (index.isValid()) {
		BookListItem i = index.data().value<BookListItem>();

		return i.title.contains(filterRegExp()) || i.author.contains(filterRegExp()) || i.username.contains(filterRegExp());
	}
	return false;
}
