#include "booklistmodel.h"
#include <QtAlgorithms>
#include <QMutableListIterator>

int BookListModel::rowCount(const QModelIndex &parent) const {
	return book_list.count();
}

QVariant BookListModel::data(const QModelIndex &index, int role) const {
	if (!index.isValid()) return QVariant();
	if (index.row() >= book_list.size()) return QVariant();
	if (role == Qt::DisplayRole || role == Qt::EditRole)
		return QVariant::fromValue( book_list.at(index.row()) );
	else
		return QVariant();
}

QVariant BookListModel::headerData(int section, Qt::Orientation orientation, int role) const {
	if (role != Qt::DisplayRole)
			 return QVariant();

	 if (orientation == Qt::Horizontal)
		 return QString(tr("Column %1")).arg(section);
	 else
		 return QString(tr("Row %1")).arg(section);
}

void BookListModel::sort(int column, Qt::SortOrder order) {
	if (order == Qt::AscendingOrder) qSort(book_list);
	else qSort(book_list.begin(), book_list.end(), qGreater<BookListItem>());
}

BookList BookListModel::getBookList() {
	return book_list;
}

void BookListModel::setBookList(BookList &lista) {
	beginResetModel();
	book_list = lista;
	endResetModel();
}
